From bfeac9639a865fcae6cb4c2e980fa61eb0a611d4 Mon Sep 17 00:00:00 2001
From: Shugo Maeda <shugo@ruby-lang.org>
Date: Fri, 22 Oct 2010 11:23:19 +0900
Subject: [PATCH 34/51] check argument type in rb_import_classbox().

---
 eval.c |    5 +++++
 1 files changed, 5 insertions(+), 0 deletions(-)

diff --git a/eval.c b/eval.c
index 172774d..24b07e8 100644
--- a/eval.c
+++ b/eval.c
@@ -864,6 +864,11 @@ rb_overlay_module(NODE *cref, VALUE klass, VALUE module)
 {
     VALUE iclass, c, superclass = klass;
 
+    if (TYPE(klass) != T_CLASS && TYPE(klass) != T_MODULE) {
+	rb_raise(rb_eTypeError,
+		 "wrong argument type %s (expected Class or Module)",
+		 rb_obj_classname(klass));
+    }
     Check_Type(module, T_MODULE);
     if (NIL_P(cref->nd_omod)) {
 	cref->nd_omod = rb_hash_new();
-- 
1.7.0.4

